﻿/*
	Afftereffects Script
	Auther: Hiroshi Takashima, Canplaize Inc.
	URL: http://www.canplaize.com/
	*/
{
	function getHtAEGridDuplicationPanel(thisObj){
		var scriptName = "2D Grid Duplicator Ver.1.0";
		var secondSelectedLayerIs = "EndCorner";
		//UI Event
		function onClickCancel(){
			my_palette.close();
		}
	
		function onClickApply(){
			//Selection Check
			var numSelectionLayer = app.project.activeItem.selectedLayers.length;
			
			if((secondSelectedLayerIs == "Offset" || secondSelectedLayerIs == "EndCorner") && numSelectionLayer < 2){
				alert("Please Select 2 Layer");
				return;
			}else if(secondSelectedLayerIs == "None" && numSelectionLayer < 1){
				alert("Please Select 1 Layer");
				return;
			}
			
			var numX = parseInt(my_palette.grp.dimensionSettingPanel.numX.numXText.text,10);
			var numY = parseInt(my_palette.grp.dimensionSettingPanel.numY.numYText.text,10);

			var startLayer = app.project.activeItem.selectedLayers[0];
			
			if(startLayer.Position.expressionEnabled){
				alert("Can't duplicate Expression enabled Layer");
				return;
			}

			if(secondSelectedLayerIs != "None"){
				var endLayer = app.project.activeItem.selectedLayers[1];
			}
			
			var divX = 0.0;
			var dixY = 0.0;
			switch(secondSelectedLayerIs){
				case "Offset":
					divX = endLayer.Position.value[0] -  startLayer.Position.value[0];
					divY = endLayer.Position.value[1] -  startLayer.Position.value[1];
					break;
				case "EndCorner":
					if(numX-1 >= 2) divX = (endLayer.Position.value[0] -  startLayer.Position.value[0])/(numX - 1);
					if(numY-1 >= 2) divY = (endLayer.Position.value[1] -  startLayer.Position.value[1])/(numY - 1);
					break;
				case "None":
					divX = parseFloat (my_palette.grp.offsetValueSettingPanel.offsetX.offsetXText.text);
					divY = parseFloat (my_palette.grp.offsetValueSettingPanel.offsetY.offsetYText.text);
					break;
			}

			app.beginUndoGroup("GridDuplication");
			for(j = 0; j<numY; j++){
				for(i=0; i<numX; i++){
					var dupli = startLayer.duplicate();
					if(!startLayer.position.isTimeVarying){
						dupli.Position.setValue([startLayer.Position.value[0] + (divX * i) , startLayer.Position.value[1] + (divY * j)]);
					}else{
						for(keyIndex = 1;keyIndex <= startLayer.Position.numKeys; keyIndex++){
							dupli.Position.setValueAtKey(keyIndex,[startLayer.Position.keyValue(keyIndex)[0] + (divX * i) ,startLayer.Position.keyValue(keyIndex)[1] + (divY * j)])
						}
					}
				}
			}
			//remove start and end layer
			startLayer.remove();
			if(secondSelectedLayerIs != "None"){
				endLayer.remove();
			}
			app.endUndoGroup();
		}
		
		var onChangeSecondLayerMode = function(panel){
			for (var i = 0; i < panel.children.length; i++) {
				if (panel.children[i].value == true) {
					secondSelectedLayerIs = panel.children[i].name;
					return;
				}
			}
		}
		
		var validateIntergerFlield = function(fld){
			if(parseInt(fld.text, 10) <= 0) fld.text = "1";
		};
	
		//Main
		if(parseFloat (app.version) < 8){
				alert("This script requires After Effects CS3 or later.", scriptName);
				return;
		}else{
			var my_palette = (thisObj instanceof Panel) ? thisObj : new Window("palette", scriptName, undefined, {resizeable:true});
			if(my_palette != null){
				var resource = "group {\
					orientation:'column', alignment:['fill','fill'], alignChildren:['left','top'], spacing:5, margins:[0,0,0,0],\
					dimensionSettingPanel:Panel{\
						text:'Dimensions',\
						alignment:['fill','top'],\
						numX:Group { \
								alignment:['fill','top'], \
								numXStr: StaticText { text:'Number of X :', alignment:['left','center'], minimumSize:[90,20]}, \
								numXText: EditText { text:'4', characters:5, alignment:['fill','center'] },\
						}, \
						numY:Group { \
								alignment:['fill','top'], \
								numYStr: StaticText { text:'Numder of Y :', alignment:['left','center'], minimumSize:[90,20]}, \
								numYText: EditText { text:'3', characters:5, alignment:['fill','center'] },\
						},\
					},\
					secondSelectLayerIs:Panel{\
						text:'Second selected layer is',\
						alignment:['fill','top'],\
						radioOffset:RadioButton {text:'Offset Reference', alignment:['left','center'], name:'Offset'},\
						radioEndCorner:RadioButton {text:'End Corner Reference', alignment:['left','center'], name:'EndCorner',value:'true'},\
						radioNone:RadioButton{text:'None(form Offset Value)', alignment:['left','center'], name:'None'},\
					},\
					offsetValueSettingPanel:Panel{\
						text:'Offset Value',\
						alignment:['fill','top'],\
						offsetX:Group { \
								alignment:['fill','top'], \
								offsetXStr: StaticText { text:'X Offset :', alignment:['left','center'], minimumSize:[90,20]}, \
								offsetXText: EditText { text:'100.0', characters:5, alignment:['fill','center'] },\
						}, \
						offsetY:Group { \
								alignment:['fill','top'], \
								offsetYStr: StaticText { text:'Y Offset :', alignment:['left','center'], minimumSize:[90,20]}, \
								offsetYText: EditText { text:'100.0', characters:5, alignment:['fill','center'] },\
						},\
					},\
					cmds:Group{\
						alignment:['right','top'], \
						cancelButton:Button{text:'Close',alignment:['left','center']},\
						applyButton:Button{text:'Apply',alignment:['left','center']},\
					}\
				}";
				
				my_palette.margins = [10,10,10,10];
				my_palette.grp = my_palette.add(resource);
				
				//Event processes
				
				my_palette.grp.dimensionSettingPanel.numX.numXText.onChange = function(){validateIntergerFlield(my_palette.grp.dimensionSettingPanel.numX.numXText);};
				my_palette.grp.dimensionSettingPanel.numY.numYText.onChange = function(){validateIntergerFlield(my_palette.grp.dimensionSettingPanel.numY.numYText);};
				my_palette.grp.cmds.cancelButton.onClick = onClickCancel;				
				my_palette.grp.cmds.applyButton.onClick = onClickApply;
				for(var i = 0; i < my_palette.grp.secondSelectLayerIs.children.length;i++){
					my_palette.grp.secondSelectLayerIs.children[i].onClick = function(){onChangeSecondLayerMode(my_palette.grp.secondSelectLayerIs);};
				}
				my_palette.onResizing = my_palette.onResize = function () {this.layout.resize();};
				//End of Events
				
				if (my_palette instanceof Window) {
					my_palette.center();
					my_palette.show();
				} else {
					my_palette.layout.layout(true);
					my_palette.layout.resize();
				}
			
			}else{
				alert("Could not open the user interface.", scriptName);
			}
		}
	}
	getHtAEGridDuplicationPanel(this);
}